#include "animation.h"

CAnimation::CAnimation(DATAFILE *toLoadFrom, int totalTime)
{
    DATAFILE *checker = toLoadFrom;
    int objects = 0;
    if(toLoadFrom != NULL)
    {
        while(checker->type != DAT_END)
        {
            if(checker->type == DAT_BITMAP)
            {
                objects++;
            }
            checker++;
        }
        int framePer = totalTime/objects;
        while(toLoadFrom->type != DAT_END)
        {
            if(toLoadFrom->type == DAT_BITMAP)
            {
                addFrame((BITMAP *)toLoadFrom->dat, framePer);
            }
            toLoadFrom++;
        }
    }
}

CAnimation::CAnimation()
{
    currFrameTimes = 0;
}

CAnimation::~CAnimation()
{
    //nothin
}

void CAnimation::addFrame(BITMAP *bitmapFrame, int time)
{
    frames.push_back(bitmapFrame);
    frameTimes.push_back(time);
    currFrame = frames.begin();
    currTime = frameTimes.begin();
    currFrameTimes = 0;
}

BITMAP *CAnimation::getCurr()
{
    return (*currFrame);
}

void CAnimation::update()
{
    if(currFrameTimes >= (*currTime))
    {
        currFrame++;
        currTime++;
        if(currFrame == frames.end())
        {
            currFrame = frames.begin();
            currTime = frameTimes.begin();
        }
        currFrameTimes = 0;
    }
    else
    {
        currFrameTimes++;
    }
}

void CAnimationR::update()
{
    if(currFrameTimes >= (*currTime))
    {
        if(currFrame == frames.begin())
        {
            currFrame = frames.end();
            currTime = frameTimes.end();
        }
        currFrame--;
        currTime--;
        currFrameTimes = 0;
    }
    else
    {
        currFrameTimes++;
    }
}
