#ifndef PREPROCENEMYHEADER
#define PREPROCENEMYHEADER

#include<allegro.h>
#ifdef WIN32
    #include<winalleg.h>
#endif

#include<vector>
using namespace std;

#include "animation.h"
#include "player.h"

class CEnemy
{
public:
    static CEnemy *instance() {return Instance;};
    static void init(DATAFILE *);
    void draw(); //draws the enemies.
    void update(CPlayer *); //updates, checks for collision
    
    void setNumber(int to, Clevel *); //sets the number of enemies (ERASES PREVIOUS ENEMIES)
    ~CEnemy();
protected:
    int w, h;
    CEnemy(DATAFILE *);
    vector<float> xVals;
    vector<float> yVals;
    vector<float> vVals;
    vector<int> tVals;
    vector<CAnimation *> animations;
    int max; //number of enemies there shoudl be
    static CEnemy *Instance;
    DATAFILE *theDatFile;
};

#endif

