#ifndef PREPROCLEVELHEADER
#define PREPROCLEVELHEADER
//levels are randomly generated then smoothed so they look nices

#include<allegro.h>
#ifdef WIN32
    #include<winalleg.h>
#endif
#include<vector>
#include<list>
using namespace std;

#include "player.h"

class CPlayer;

class Clevel
{
public:
    Clevel(int w, int h, int bMax, int enemies, DATAFILE *dataFile); //makes a level that high and wide with bMax being the ~max number of blocks (still is random)
    ~Clevel();
    
    void draw();
    
    bool checkCollision(int x, int y, int w, int h); //checks a collision against the map uses bounding box collision
    
    void setToStart(CPlayer *);
    
    int getWidth() {return width;};
    int getHeight() {return height;};
    
protected:
    int getLoc(int x, int y) {return blocks[y][x];};
    int blocksOnRow(int r);
    void setLoc(int x, int y, int to) {blocks[y][x] = to;};
    vector<vector<int> > blocks; //stores where blocks are
    vector<BITMAP *> blockBitmaps; //stores block images
    int width;
    int height;
};

#endif
